<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suifmath.texi on 28 April 1999 -->

<TITLE>The SUIFMATH Library - Matrix Manipulation</TITLE>
<link href="suifmath_5.html" rel=Next>
<link href="suifmath_3.html" rel=Previous>
<link href="suifmath_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_3.html">previous</A>, <A HREF="suifmath_5.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC4" HREF="suifmath_toc.html#TOC4">Matrix Manipulation</A></H2>
<P>
<A NAME="IDX30"></A>
<A NAME="IDX31"></A>

</P>
<P>
The following functions create, resize, reshape, permute and compose
matrices.  
In this list of functions, symbols <VAR>A</VAR>, <VAR>B</VAR> and <VAR>C</VAR> are
of the class <CODE>integer_matrix</CODE>; <VAR>a</VAR> and <VAR>c</VAR> are a single
row of the matrix (class <CODE>integer_row</CODE>) and <VAR>m</VAR>, <VAR>n</VAR>,
<VAR>i</VAR> and <VAR>j</VAR> are integers.

</P>
<P>
<A NAME="IDX32"></A>
<A NAME="IDX33"></A>
<DL COMPACT>

<DT><CODE>integer_matrix A();</CODE>
<DD>
<DT><CODE>A.init();</CODE>
<DD>
Create/initialize an empty matrix.
<A NAME="IDX34"></A>
<A NAME="IDX35"></A>

<DT><CODE>integer_matrix A(i, j);</CODE>
<DD>
<DT><CODE>A.init(i, j);</CODE>
<DD>
Create/initialize a matrix of <VAR>i</VAR> rows and <VAR>j</VAR> columns.
<A NAME="IDX36"></A>
<A NAME="IDX37"></A>

<DT><CODE>integer_matrix A(B);</CODE>
<DD>
<DT><CODE>integer_matrix A(&#38;B);</CODE>
<DD>
<DT><CODE>A.init(B);</CODE>
<DD>
<DT><CODE>A.init(&#38;B);</CODE>
<DD>
Create/initialize matrix <VAR>A</VAR> to be identical to <VAR>B</VAR>.
<A NAME="IDX38"></A>
<A NAME="IDX39"></A>
<A NAME="IDX40"></A>
<A NAME="IDX41"></A>

<DT><CODE>integer_matrix A(B, m);</CODE>
<DD>
<DT><CODE>integer_matrix A(&#38;B, m);</CODE>
<DD>
<DT><CODE>A.init(B, m);</CODE>
<DD>
<DT><CODE>A.init(&#38;B, m);</CODE>
<DD>
Create/initialize matrix <VAR>A</VAR> such that it has <VAR>m</VAR> rows
identical to the first <VAR>m</VAR> rows of  <VAR>B</VAR>.  If <VAR>B</VAR> has less
that <VAR>m</VAR> rows, <VAR>A</VAR> is padded with rows (with elements set to
0).
<A NAME="IDX42"></A>
<A NAME="IDX43"></A>
<A NAME="IDX44"></A>
<A NAME="IDX45"></A>

<DT><CODE>immed_list ilist;</CODE>
<DD>
<DT><CODE>j = A.init(ilist);</CODE>
<DD>
<DT><CODE>j = A.init(ilist, i);</CODE>
<DD>
These conversion routines are useful for storing and retrieving matrices
to/from SUIF annotations.  <CODE>immed</CODE> is a class abstraction used
by SUIF compiler to store values of different types. Matrix <VAR>A</VAR>
is initialized from a specially created list of <CODE>immed</CODE>s (starting
from position <VAR>i</VAR>). The integer variable <VAR>j</VAR> gets the next
position of the list after reading in the matrix.
<DT><CODE>immed_list * il = A.cvt_immed_list();</CODE>
<DD>
Create an <CODE>immed_list</CODE> from the matrix <VAR>A</VAR>. These functions
are used when matrices are stored as annotations.
<A NAME="IDX46"></A>
<A NAME="IDX47"></A>
<A NAME="IDX48"></A>
<A NAME="IDX49"></A>

<DT><CODE>A = Compose(row, col, int, int, int, ...)</CODE>
<DD>
Compose a matrix using individual elements.

<BLOCKQUOTE>

<PRE>
A = Compose(2, 3, 
            i11, i12, i13, 
            i21, i22, i23);
</PRE>

<P>
will create a 2x3 matrix initialized to the integers given. Thus
<VAR>A</VAR> is: 

<PRE>
        [ i11, i12, i13 ]
        [ i21, i22, i23 ]
</PRE>

<A NAME="IDX50"></A>
<A NAME="IDX51"></A>
</BLOCKQUOTE>

<DT><CODE>nim_op O;</CODE>
<DD>
<DT><CODE>A = Compose(row, col, O.NIM(...) or NULL, O.NIM(...) or NULL, ...)</CODE>
<DD>
Compose a matrix by combining many different matrices.

<BLOCKQUOTE>

<PRE>
nim_op O;
A = Compose(2, 3, 
            O.NIM(B11), O.NIM(B12), NULL, 
            NULL,       O.NIM(B22), O.NIM(i,j));
</PRE>

<P>
will create the matrix:

<PRE>
        [ [B11]  [B12]    0   ]
        [   0    [B21]  [ixj] ]
</PRE>

</BLOCKQUOTE>

where all the matrices contributing to a row have the same number of
rows and matrices contributing to a column have the same number of
columns -- except when an entry is NULL.  Then, that space is stuffed
with zeros according to the size dictated by other elements in its row
and column.  Thus, each row and column should have at least one entry
that is not NULL.  The function <CODE>NIM</CODE> is used as a wrap-around for
all the input matrices. <CODE>NIM(i, j)</CODE> creates an <VAR>i</VAR>x<VAR>j</VAR>
matrix and <CODE>NIM(x)</CODE> creates a single element with the value
<VAR>x</VAR>. The wrappers created by the calls to <CODE>O.NIM(...)</CODE> will be 
deleted when the <CODE>nim_op</CODE> object <VAR>O</VAR> is deleted.

<BLOCKQUOTE>
<P>
The following example further illustrates the use of
<CODE>Compose</CODE>.
<A NAME="IDX52"></A>
<A NAME="IDX53"></A>
<A NAME="IDX54"></A>
<A NAME="IDX55"></A>

<PRE>
lin_ineq A = Compose(2, 2,
                     1  2
                     3  4);
lin_ineq B(1, 3);
B = 2;
nim_op O;
lin_ineq C = Compose(2, 2,
                     O.NIM(A),   0,
                     O.NIM(1,2), 0,
                          0,     O.NIM(B));
</PRE>

<P>
The matrices are:

<PRE>
A =  [ 1  2 ]            [ 1  2  0  0  0 ]
     [ 3  4 ]       C =  [ 3  4  0  0  0 ]
                         [ 0  0  0  0  0 ]
B =  [ 2  2  2 ]         [ 0  0  2  2  2 ]
</PRE>

</BLOCKQUOTE>

<DT><CODE>A = Ident(i);</CODE>
<DD>
Create an identity matrix of size <VAR>i</VAR>.
<A NAME="IDX56"></A>
<A NAME="IDX57"></A>
</DL>

<DL COMPACT>

<DT><CODE>A.del_row(i);</CODE>
<DD>
<DT><CODE>A.del_row(i, j);</CODE>
<DD>
Delete the <VAR>i</VAR>-th row (or rows <VAR>i</VAR> to <VAR>j</VAR>) from matrix
<VAR>A</VAR>. 
<A NAME="IDX58"></A>
<A NAME="IDX59"></A>
<A NAME="IDX60"></A>

<DT><CODE>A.del_col(i);</CODE>
<DD>
<DT><CODE>A.del_col(i, j);</CODE>
<DD>
Delete the <VAR>i</VAR>-th column (or columns <VAR>i</VAR> to <VAR>j</VAR>) from
matrix <VAR>A</VAR>. 
<A NAME="IDX61"></A>
<A NAME="IDX62"></A>
<A NAME="IDX63"></A>

<DT><CODE>B = A.del_columns(a);</CODE>
<DD>
If the <EM>k</EM>-th entry of the row <VAR>a</VAR> is non zero (set to 1) then
the <EM>k</EM>-th column of the matrix <VAR>A</VAR> is eliminated from the output.
<A NAME="IDX64"></A>
<A NAME="IDX65"></A>

<DT><CODE>A.insert_col(i);</CODE>
<DD>
Insert a column initialized to 0 at the <VAR>i</VAR>-th position.
<A NAME="IDX66"></A>
<A NAME="IDX67"></A>

<DT><CODE>B = A.swap(i, j);</CODE>
<DD>
<DT><CODE>A[i] ^= A[j];</CODE>
<DD>
Swap the rows <VAR>i</VAR> and <VAR>j</VAR>. In using <CODE>^=</CODE>, the current
matrix <VAR>A</VAR> is updated.
<A NAME="IDX68"></A>
<A NAME="IDX69"></A>
<A NAME="IDX70"></A>

<DT><CODE>B = A.swap_col(i, j);</CODE>
<DD>
Swap the columns <VAR>i</VAR> and <VAR>j</VAR>.
<A NAME="IDX71"></A>
<A NAME="IDX72"></A>

<DT><CODE>B = A%a;</CODE>
<DD>
Permute the rows of A using the position given by <VAR>a</VAR>; where, for
each row <EM>x</EM>, B[x] = A[a[x]].
<A NAME="IDX73"></A>
<A NAME="IDX74"></A>

<DT><CODE>B = A.resize(il, iu, jl, ju);</CODE>
<DD>
<DT><CODE>B = A.resize(il, iu, jl, ju, fill);</CODE>
<DD>
If <VAR>il &#62;= 0</VAR>, the first row of matrix <VAR>B</VAR> will be the
<VAR>il</VAR>-th row of matrix <VAR>A</VAR>, otherwise (<VAR>il &#60; 0</VAR>) the first
<VAR>(-il)</VAR>-th rows of <VAR>B</VAR> are all zeros while the <VAR>(1-il)</VAR>-th row
is the first row of <VAR>A</VAR>. If <VAR>iu&#60;=A.m()</VAR>, the last row of
<VAR>B</VAR> is the <VAR>iu</VAR>-th row of <VAR>A</VAR>, while if <VAR>iu&#62;A.m()</VAR>
the last <VAR>iu-A.m()</VAR> rows of <VAR>B</VAR> are zeros. The technique using
<VAR>jl</VAR> and <VAR>ju</VAR> applies to the columns.
If <VAR>fill</VAR> is set, the padded rows and columns will have the value
<VAR>fill</VAR> instead of zero.
<A NAME="IDX75"></A>
<A NAME="IDX76"></A>

<BLOCKQUOTE>
<P>
For example:

<PRE>
  B  = A.resize(1, 3, 2, 7);
</PRE>

<P>
where

<PRE>

    [  0   1   2   3   4 ]      [ 12  13  14  0  0  0 ]
    [ 10  11  12  13  14 ]  B = [ 22  23  24  0  0  0 ]
A = [ 20  21  22  23  24 ]      [ 32  33  34  0  0  0 ]
    [ 30  31  32  33  34 ]
    [ 40  41  42  43  44 ]
</PRE>

</BLOCKQUOTE>

<DT><CODE>B = A.resize_offset(il, iu, jl, ju);</CODE>
<DD>
<DT><CODE>B = A.resize_offset(il, iu, jl, ju, fill);</CODE>
<DD>
Create a matrix <VAR>B</VAR> by resizing <VAR>A</VAR>. If <VAR>il &#62;= 0</VAR>,
the <VAR>il</VAR>-th row of A is the first row of <VAR>B</VAR>, otherwise
<VAR>(-il)</VAR>-blank rows are inserted in <VAR>B</VAR> before the first row of
<VAR>A</VAR> is inserted.  If <VAR>iu &#60;= 0</VAR>, the last row of <VAR>B</VAR> is
<VAR>(B.m()+iu)</VAR>-th row of <VAR>A</VAR>. Otherwise, <VAR>iu</VAR> blank rows are
inserted in <VAR>B</VAR> after the last row of <VAR>A</VAR>. The same applies
for the columns.
If <VAR>fill</VAR> is set, the padded rows and columns will have the value
<VAR>fill</VAR> instead of zero.
<A NAME="IDX77"></A>

<BLOCKQUOTE>
<P>
For example:

<PRE>
  B  = A.resize_offset(1, -1, 2, 3);
</PRE>

<P>
where

<PRE>
    [  0   1   2   3   4 ]      [ 12  13  14  0  0  0 ]
    [ 10  11  12  13  14 ]  B = [ 22  23  24  0  0  0 ]
A = [ 20  21  22  23  24 ]      [ 32  33  34  0  0  0 ]
    [ 30  31  32  33  34 ]
    [ 40  41  42  43  44 ]
</PRE>

</BLOCKQUOTE>

<DT><CODE>C = A &#38; B;</CODE>
<DD>
<DT><CODE>C = r_merge(A, B);</CODE>
<DD>
The resulting matrix <VAR>C</VAR> is:

<PRE>
        [ A ]
        [ B ]
</PRE>

This is same as <CODE>C = Compose(2, 1, O.NIM(A), O.NIM(B));</CODE>.
<A NAME="IDX78"></A>
<A NAME="IDX79"></A>
<A NAME="IDX80"></A>

<DT><CODE>C = A | B;</CODE>
<DD>
<DT><CODE>C = c_merge(A, B);</CODE>
<DD>
The resulting matrix <VAR>C</VAR> is:

<PRE>
        [ A  B ]
</PRE>

This is same as <CODE>C = Compose(1, 2, O.NIM(A), O.NIM(B));</CODE>.
</DL>
<P>
<A NAME="IDX81"></A>
<A NAME="IDX82"></A>

</P>
<P>
The matrix library also can create permutation matrices and row-column
switch and add matrices.
<A NAME="IDX83"></A>
<A NAME="IDX84"></A>
<A NAME="IDX85"></A>
<DL COMPACT>

<DT><CODE>B = rowswitch(A, i, j);</CODE>
<DD>
<VAR>B*A</VAR> will result in a matrix that is identical to <VAR>A</VAR> except
the <VAR>i</VAR> and <VAR>j</VAR> rows are interchanged.
<A NAME="IDX86"></A>

<DT><CODE>B = colswitch(A, i, j);</CODE>
<DD>
<VAR>A*B</VAR> will result in a matrix that is identical to <VAR>A</VAR> except
the <VAR>i</VAR> and <VAR>j</VAR> columns are interchanged.
<A NAME="IDX87"></A>

<DT><CODE>B = rowadd(A, i, j, x);</CODE>
<DD>
<VAR>B*A</VAR> will result in a matrix that is identical to <VAR>A</VAR> except
the <VAR>i</VAR>-th row. The values in that row are, for <VAR>0&#60;=k&#60;A.n()</VAR>
<VAR>B[i][k] = A[i][k] + x*A[j][k]</VAR>. 
<A NAME="IDX88"></A>

<DT><CODE>B = coladd(A, i, j, x);</CODE>
<DD>
<VAR>B*A</VAR> will result in a matrix that is identical to <VAR>A</VAR> except
for the <VAR>i</VAR>-th column. The values in that column are
<VAR>0&#60;=k&#60;A.m()</VAR> <VAR>B[k][i] = A[k][i] + x*A[k][j]</VAR>.  
<A NAME="IDX89"></A>
</DL>

<P><HR><P>
<p>Go to the <A HREF="suifmath_1.html">first</A>, <A HREF="suifmath_3.html">previous</A>, <A HREF="suifmath_5.html">next</A>, <A HREF="suifmath_37.html">last</A> section, <A HREF="suifmath_toc.html">table of contents</A>.
</BODY>
</HTML>
